#include <SoftwareSerial.h>
#include <OneWire.h>
#include <DallasTemperature.h>


// Data wire is plugged into port 2 on the Arduino
// Data wire is plugged into port 2 on the Arduino
#define SERIAL_RX 3
#define SERIAL_TX 4
#define ONE_WIRE_BUS 2

// Setup a oneWire instance to communicate with any OneWire devices
OneWire oneWire(ONE_WIRE_BUS);

// Pass our oneWire reference to Dallas Temperature.
DallasTemperature sensors(&oneWire);

SoftwareSerial TinySerial(SERIAL_RX, SERIAL_TX);

// Addresses of 3 DS18B20s
uint8_t sensor1[8] = { 0x28, 0xFA, 0x78, 0xC9, 0x03, 0x00, 0x00, 0xBE };
uint8_t sensor2[8] = { 0x28, 0x37, 0xDC, 0x4A, 0x04, 0x00, 0x00, 0x6C };
uint8_t sensor3[8] = { 0x28, 0xBF, 0x0C, 0x4B, 0x04, 0x00, 0x00, 0xF6 };

void setup(void)
{
  TinySerial.begin(4800);
  sensors.begin();
}

void loop(void)
{
  sensors.requestTemperatures();

  if (TinySerial.available()){
  TinySerial.print("Sensor 1: ");
  printTemperature(sensor1);
  
  TinySerial.print("Sensor 2: ");
  printTemperature(sensor2);
  
  TinySerial.print("Sensor 3: ");
  printTemperature(sensor3);
  
  TinySerial.println();
  delay(1000);
  }
}

void printTemperature(DeviceAddress deviceAddress)
{
  float tempC = sensors.getTempC(deviceAddress);
  TinySerial.print(tempC);
  TinySerial.print((char)176);
  TinySerial.print("C  |  ");
  TinySerial.print(DallasTemperature::toFahrenheit(tempC));
  TinySerial.print((char)176);
  TinySerial.println("F");
}
